----------------------------------------------------------------------------------------------------
-- (c)2011 Altera Corporation. All rights reserved.
--
-- Altera products are protected under numerous U.S. and foreign patents,
-- maskwork rights, copyrights and other intellectual property laws.
--
-- This reference design file, and your use thereof, is subject to and governed
-- by the terms and conditions of the applicable Altera Reference Design License
-- Agreement (either as signed by you or found at www.altera.com).  By using
-- this reference design file, you indicate your acceptance of such terms and
-- conditions between you and Altera Corporation.  In the event that you do not
-- agree with such terms and conditions, you may not use the reference design
-- file and please promptly destroy any copies you have made.
--
-- This reference design file is being provided on an "as-is�" basis and as an
-- accommodation and therefore all warranties, representations or guarantees of
-- any kind (whether express, implied or statutory) including, without
-- limitation, warranties of merchantability, non-infringement, or fitness for
-- a particular purpose, are specifically disclaimed.  By making this reference
-- design file available, Altera expressly does not recommend, suggest or
-- require that this reference design file be used in combination with any
-- other product not provided by Altera.
----------------------------------------------------------------------------------------------------
-- Author		 : Peter Schepers (pscheper)
----------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity descrambler is
GENERIC
(
	WIDTH  : integer range 0 to 512 :=64
);
PORT
(
	clk						: in std_logic; 						
	arst					: in std_logic;	
	ena						: in std_logic;   						
	din						: in std_logic_vector(WIDTH-1 downto 0);	
	dout					: out std_logic_vector(WIDTH-1 downto 0)
 );
END descrambler;
  
architecture rtl of descrambler is

signal scram_state 		: std_logic_vector(57 downto 0);
signal history			: std_logic_vector(WIDTH+58-1 downto 0);
signal dout_w			: std_logic_vector(WIDTH-1 downto 0);


begin

history <= din & scram_state;

Generate_history:
FOR i IN 0 to WIDTH-1 GENERATE
	dout_w(i)	<= history(58+i-58) xor history(58+i-39) xor history(58+i);
end generate;

process(clk,arst)
begin
	if arst = '1' then
		dout 			<= (OTHERS => '0');
		scram_state 	<= (OTHERS => '1');
	elsif rising_edge(clk) then
		if ena = '1' then
			dout 		<= dout_w;
			scram_state <= history(WIDTH+58-1 downto WIDTH);
		end if;
	end if;
end process;

end;
		
