----------------------------------------------------------------------------------------------------
-- (c)2011 Altera Corporation. All rights reserved.
--
-- Altera products are protected under numerous U.S. and foreign patents,
-- maskwork rights, copyrights and other intellectual property laws.
--
-- This reference design file, and your use thereof, is subject to and governed
-- by the terms and conditions of the applicable Altera Reference Design License
-- Agreement (either as signed by you or found at www.altera.com).  By using
-- this reference design file, you indicate your acceptance of such terms and
-- conditions between you and Altera Corporation.  In the event that you do not
-- agree with such terms and conditions, you may not use the reference design
-- file and please promptly destroy any copies you have made.
--
-- This reference design file is being provided on an "as-is�" basis and as an
-- accommodation and therefore all warranties, representations or guarantees of
-- any kind (whether express, implied or statutory) including, without
-- limitation, warranties of merchantability, non-infringement, or fitness for
-- a particular purpose, are specifically disclaimed.  By making this reference
-- design file available, Altera expressly does not recommend, suggest or
-- require that this reference design file be used in combination with any
-- other product not provided by Altera.

----------------------------------------------------------------------------------------------------
-- Author		 : Peter Schepers (pscheper), converted from Verilog source from baeckler
----------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity scrambler is
GENERIC
(
	WIDTH  : integer range 0 to 512 :=64
);
PORT
(
	clk						: in std_logic; 						
	arst					: in std_logic;	
	ena						: in std_logic;   						
	din						: in std_logic_vector(WIDTH-1 downto 0);	
	dout					: out std_logic_vector(WIDTH-1 downto 0)
 );
END scrambler;
  
architecture rtl of scrambler is

signal scram_state 		: std_logic_vector(57 downto 0);
signal history			: std_logic_vector(WIDTH+58-1 downto 0);


begin

history(57 downto 0) <= scram_state;

Generate_history:
FOR i IN 58 to WIDTH+58-1 GENERATE
	history(i) <= history(i-58) xor history(i-39) xor din(i-58);
end generate;

process(clk,arst)
begin
	if arst = '1' then
		dout 			<= (OTHERS => '0');
		scram_state 	<= (OTHERS => '1');
	elsif rising_edge(clk) then
		if ena = '1' then
			dout 		<= history(WIDTH+58-1 downto 58);
			scram_state <= history(WIDTH+58-1 downto WIDTH);
		end if;
	end if;
end process;

end;
		
