package altera_xcvr_atx_pll_a10_reconfig_parameters;

localparam ram_depth = 22;
function [25:0] get_ram_data;
  input integer index;
  automatic reg [0:21][25:0] ram_data = {
    26'h102FFB6, // [25:16]-DPRIO address=0x102; [15:8]-bit mask=0xFF; [7:5]-atx_pll_tank_voltage_fine=vreg_setting5(3'h5); [4:3]-atx_pll_tank_sel=lctank2(2'h2); [2:0]-atx_pll_tank_band=lc_band6(3'h6);
    26'h103BF21, // [25:16]-DPRIO address=0x103; [15:8]-bit mask=0xBF; [7:7]-atx_pll_vco_bypass_enable=false(1'h0); [5:5]-atx_pll_cp_compensation_enable=true(1'h1); [4:2]-atx_pll_cp_testmode=cp_normal(3'h0); [1:1]-atx_pll_dsm_ecn_test_en=false(1'h0); [0:0]-atx_pll_lc_mode=lccmu_normal(1'h1);
    26'h1047F35, // [25:16]-DPRIO address=0x104; [15:8]-bit mask=0x7F; [6:4]-atx_pll_cp_current_setting=cp_current_setting22(3'h3); [3:2]-atx_pll_lf_ripplecap=lf_ripple_cap_0(2'h1); [1:0]-atx_pll_lf_resistance=lf_setting1(2'h1);
    26'h1054701, // [25:16]-DPRIO address=0x105; [15:8]-bit mask=0x47; [6:6]-atx_pll_l_counter_enable=true(1'h0); [2:0]-atx_pll_cp_current_setting=cp_current_setting22(3'h1);
    26'h1063F32, // [25:16]-DPRIO address=0x106; [15:8]-bit mask=0x3F; [5:4]-atx_pll_lf_cbig_size=lf_cbig_setting4(2'h3); [3:2]-atx_pll_cp_lf_3rd_pole_freq=lf_3rd_pole_setting0(2'h0); [1:1]-atx_pll_cp_lf_order=lf_3rd_order(1'h1); [0:0]-atx_pll_regulator_bypass=reg_enable(1'h0);
    26'h1073C00, // [25:16]-DPRIO address=0x107; [15:8]-bit mask=0x3C; [5:5]-atx_pll_enable_hclk=hclk_disabled(1'h0); [4:4]-atx_pll_dsm_mode=dsm_mode_integer(1'h0); [3:2]-atx_pll_ref_clk_div=1(2'h0);
    26'h1087F09, // [25:16]-DPRIO address=0x108; [15:8]-bit mask=0x7F; [6:5]-atx_pll_lc_to_fpll_l_counter=lcounter_setting0(2'h0); [4:4]-atx_pll_fpll_refclk_selection=select_vco_output(1'h0); [3:3]-atx_pll_d2a_voltage=d2a_setting_4(1'h1); [2:0]-atx_pll_l_counter=2(3'h1);
    26'h109FF32, // [25:16]-DPRIO address=0x109; [15:8]-bit mask=0xFF; [7:0]-atx_pll_m_counter=50(8'h32);
    26'h10A7F04, // [25:16]-DPRIO address=0x10A; [15:8]-bit mask=0x7F; [6:6]-atx_pll_cascadeclk_test=cascadetest_off(1'h0); [5:3]-atx_pll_lc_to_fpll_l_counter=lcounter_setting0(3'h0); [2:0]-atx_pll_underrange_voltage=under_setting4(3'h4);
    26'h10BE100, // [25:16]-DPRIO address=0x10B; [15:8]-bit mask=0xE1; [7:7]-atx_pll_dsm_ecn_bypass=false(1'h0); [6:5]-atx_pll_dsm_out_sel=pll_dsm_disable(2'h0); [0:0]-atx_pll_xcpvco_xchgpmplf_cp_current_boost=normal_setting(1'h0);
    26'h10CFF01, // [25:16]-DPRIO address=0x10C; [15:8]-bit mask=0xFF; [7:0]-atx_pll_dsm_fractional_division=1(8'h1);
    26'h10DFF00, // [25:16]-DPRIO address=0x10D; [15:8]-bit mask=0xFF; [7:0]-atx_pll_dsm_fractional_division=1(8'h0);
    26'h10EFF00, // [25:16]-DPRIO address=0x10E; [15:8]-bit mask=0xFF; [7:0]-atx_pll_dsm_fractional_division=1(8'h0);
    26'h10FFF00, // [25:16]-DPRIO address=0x10F; [15:8]-bit mask=0xFF; [7:0]-atx_pll_dsm_fractional_division=1(8'h0);
    26'h1103D15, // [25:16]-DPRIO address=0x110; [15:8]-bit mask=0x3D; [5:3]-atx_pll_iqclk_mux_sel=iqtxrxclk0(3'h2); [2:2]-atx_pll_fb_select=direct_fb(1'h1); [0:0]-atx_pll_dsm_fractional_value_ready=pll_k_ready(1'h1);
    26'h1117000, // [25:16]-DPRIO address=0x111; [15:8]-bit mask=0x70; [6:4]-atx_pll_overrange_voltage=over_setting0(3'h0);
    26'h118C0C0, // [25:16]-DPRIO address=0x118; [15:8]-bit mask=0xC0; [7:6]-atx_pll_lf_cbig_size=lf_cbig_setting4(2'h3);
    26'h11AE080, // [25:16]-DPRIO address=0x11A; [15:8]-bit mask=0xE0; [7:5]-atx_pll_d2a_voltage=d2a_setting_4(3'h4);
    26'h11BC000, // [25:16]-DPRIO address=0x11B; [15:8]-bit mask=0xC0; [7:6]-atx_pll_pfd_delay_compensation=normal_delay(2'h0);
    26'h11CE000, // [25:16]-DPRIO address=0x11C; [15:8]-bit mask=0xE0; [7:5]-atx_pll_tank_voltage_coarse=vreg_setting_coarse0(3'h0);
    26'h11DE000, // [25:16]-DPRIO address=0x11D; [15:8]-bit mask=0xE0; [7:5]-atx_pll_output_regulator_supply=vreg1v_setting0(3'h0);
    26'h11F6000  // [25:16]-DPRIO address=0x11F; [15:8]-bit mask=0x60; [6:5]-atx_pll_pfd_pulse_width=pulse_width_setting0(2'h0);
};

  begin
  get_ram_data = ram_data[index];
  end
endfunction

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_POWERDOWN_MODE_VALUE = "powerup";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_REFCLK_SELECT_VALUE = "ref_iqclk0";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_SILICON_REV_VALUE = "20nm4";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_INCLK0_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "ref_iqclk0";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_INCLK1_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_INCLK2_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_INCLK3_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam HSSI_PMA_LC_REFCLK_SELECT_MUX_INCLK4_LOGICAL_TO_PHYSICAL_MAPPING_VALUE = "power_down";

localparam HSSI_REFCLK_DIVIDER_SILICON_REV_VALUE = "20nm4";

localparam ATX_PLL_IS_CASCADED_PLL_VALUE = "false";

localparam ATX_PLL_CGB_DIV_VALUE = 1;

localparam ATX_PLL_PMA_WIDTH_VALUE = 40;

localparam ATX_PLL_CP_COMPENSATION_ENABLE_VALUE = "true";
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_OFST = 259;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_HIGH = 5;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_BITMASK = 32'h00000020;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_VALMASK = 32'h00000020;
localparam ATX_PLL_CP_COMPENSATION_ENABLE_ADDR_FIELD_VALUE = 1'h1;

localparam ATX_PLL_CP_CURRENT_SETTING_VALUE = "cp_current_setting22";
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_OFST = 260;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_OFST = 4;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_HIGH = 6;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_SIZE = 3;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_BITMASK = 32'h00000070;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_VALMASK = 32'h00000030;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR0_FIELD_VALUE = 3'h3;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_OFST = 261;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_OFST = 0;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_HIGH = 2;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_SIZE = 3;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_BITMASK = 32'h00000007;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_CP_CURRENT_SETTING_ADDR1_FIELD_VALUE = 3'h1;

localparam ATX_PLL_CP_TESTMODE_VALUE = "cp_normal";
localparam ATX_PLL_CP_TESTMODE_ADDR_OFST = 259;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_OFST = 2;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_HIGH = 4;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_BITMASK = 32'h0000001C;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_CP_TESTMODE_ADDR_FIELD_VALUE = 3'h0;

localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_VALUE = "lf_3rd_pole_setting0";
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_OFST = 262;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_OFST = 2;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_HIGH = 3;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_CP_LF_3RD_POLE_FREQ_ADDR_FIELD_VALUE = 2'h0;

localparam ATX_PLL_LF_CBIG_SIZE_VALUE = "lf_cbig_setting4";
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_OFST = 262;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_OFST = 4;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_HIGH = 5;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_SIZE = 2;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_BITMASK = 32'h00000030;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_VALMASK = 32'h00000030;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR0_FIELD_VALUE = 2'h3;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_OFST = 280;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_OFST = 6;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_HIGH = 7;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_SIZE = 2;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_BITMASK = 32'h000000C0;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_VALMASK = 32'h000000C0;
localparam ATX_PLL_LF_CBIG_SIZE_ADDR1_FIELD_VALUE = 2'h3;

localparam ATX_PLL_CP_LF_ORDER_VALUE = "lf_3rd_order";
localparam ATX_PLL_CP_LF_ORDER_ADDR_OFST = 262;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_OFST = 1;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_HIGH = 1;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_BITMASK = 32'h00000002;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_VALMASK = 32'h00000002;
localparam ATX_PLL_CP_LF_ORDER_ADDR_FIELD_VALUE = 1'h1;

localparam ATX_PLL_LF_RESISTANCE_VALUE = "lf_setting1";
localparam ATX_PLL_LF_RESISTANCE_ADDR_OFST = 260;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_HIGH = 1;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_BITMASK = 32'h00000003;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_LF_RESISTANCE_ADDR_FIELD_VALUE = 2'h1;

localparam ATX_PLL_LF_RIPPLECAP_VALUE = "lf_ripple_cap_0";
localparam ATX_PLL_LF_RIPPLECAP_ADDR_OFST = 260;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_OFST = 2;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_HIGH = 3;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_VALMASK = 32'h00000004;
localparam ATX_PLL_LF_RIPPLECAP_ADDR_FIELD_VALUE = 2'h1;

localparam ATX_PLL_TANK_SEL_VALUE = "lctank2";
localparam ATX_PLL_TANK_SEL_ADDR_OFST = 258;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_OFST = 3;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_HIGH = 4;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_BITMASK = 32'h00000018;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_VALMASK = 32'h00000010;
localparam ATX_PLL_TANK_SEL_ADDR_FIELD_VALUE = 2'h2;

localparam ATX_PLL_TANK_BAND_VALUE = "lc_band6";
localparam ATX_PLL_TANK_BAND_ADDR_OFST = 258;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_HIGH = 2;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_BITMASK = 32'h00000007;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_VALMASK = 32'h00000006;
localparam ATX_PLL_TANK_BAND_ADDR_FIELD_VALUE = 3'h6;

localparam ATX_PLL_TANK_VOLTAGE_COARSE_VALUE = "vreg_setting_coarse0";
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_OFST = 284;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_BITMASK = 32'h000000E0;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_TANK_VOLTAGE_COARSE_ADDR_FIELD_VALUE = 3'h0;

localparam ATX_PLL_TANK_VOLTAGE_FINE_VALUE = "vreg_setting5";
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_OFST = 258;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_BITMASK = 32'h000000E0;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_VALMASK = 32'h000000A0;
localparam ATX_PLL_TANK_VOLTAGE_FINE_ADDR_FIELD_VALUE = 3'h5;

localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_VALUE = "vreg1v_setting0";
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_OFST = 285;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_BITMASK = 32'h000000E0;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_OUTPUT_REGULATOR_SUPPLY_ADDR_FIELD_VALUE = 3'h0;

localparam ATX_PLL_OVERRANGE_VOLTAGE_VALUE = "over_setting0";
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_OFST = 273;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_OFST = 4;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_HIGH = 6;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_BITMASK = 32'h00000070;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_OVERRANGE_VOLTAGE_ADDR_FIELD_VALUE = 3'h0;

localparam ATX_PLL_UNDERRANGE_VOLTAGE_VALUE = "under_setting4";
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_OFST = 266;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_HIGH = 2;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_BITMASK = 32'h00000007;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_VALMASK = 32'h00000004;
localparam ATX_PLL_UNDERRANGE_VOLTAGE_ADDR_FIELD_VALUE = 3'h4;

localparam ATX_PLL_FB_SELECT_VALUE = "direct_fb";
localparam ATX_PLL_FB_SELECT_ADDR_OFST = 272;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_OFST = 2;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_HIGH = 2;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_BITMASK = 32'h00000004;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_VALMASK = 32'h00000004;
localparam ATX_PLL_FB_SELECT_ADDR_FIELD_VALUE = 1'h1;

localparam ATX_PLL_D2A_VOLTAGE_VALUE = "d2a_setting_4";
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_OFST = 264;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_OFST = 3;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_HIGH = 3;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_SIZE = 1;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_BITMASK = 32'h00000008;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_VALMASK = 32'h00000008;
localparam ATX_PLL_D2A_VOLTAGE_ADDR0_FIELD_VALUE = 1'h1;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_OFST = 282;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_OFST = 5;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_HIGH = 7;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_SIZE = 3;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_BITMASK = 32'h000000E0;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_VALMASK = 32'h00000080;
localparam ATX_PLL_D2A_VOLTAGE_ADDR1_FIELD_VALUE = 3'h4;

localparam ATX_PLL_DSM_MODE_VALUE = "dsm_mode_integer";
localparam ATX_PLL_DSM_MODE_ADDR_OFST = 263;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_OFST = 4;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_HIGH = 4;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_BITMASK = 32'h00000010;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_MODE_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_DSM_OUT_SEL_VALUE = "pll_dsm_disable";
localparam ATX_PLL_DSM_OUT_SEL_ADDR_OFST = 267;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_HIGH = 6;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_BITMASK = 32'h00000060;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_OUT_SEL_ADDR_FIELD_VALUE = 2'h0;

localparam ATX_PLL_DSM_ECN_BYPASS_VALUE = "false";
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_OFST = 267;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_OFST = 7;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_BITMASK = 32'h00000080;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_ECN_BYPASS_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_DSM_ECN_TEST_EN_VALUE = "false";
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_OFST = 259;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_OFST = 1;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_HIGH = 1;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_BITMASK = 32'h00000002;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_ECN_TEST_EN_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_VALUE = "1";
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_OFST = 268;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_OFST = 0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_HIGH = 7;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_SIZE = 8;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_BITMASK = 32'h000000FF;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR0_FIELD_VALUE = 8'h1;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_OFST = 269;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_OFST = 0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_HIGH = 7;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_SIZE = 8;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_BITMASK = 32'h000000FF;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR1_FIELD_VALUE = 8'h0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_OFST = 270;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_OFST = 0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_HIGH = 7;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_SIZE = 8;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_BITMASK = 32'h000000FF;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR2_FIELD_VALUE = 8'h0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_OFST = 271;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_OFST = 0;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_HIGH = 7;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_SIZE = 8;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_BITMASK = 32'h000000FF;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_DSM_FRACTIONAL_DIVISION_ADDR3_FIELD_VALUE = 8'h0;

localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_VALUE = "pll_k_ready";
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_OFST = 272;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_HIGH = 0;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_BITMASK = 32'h00000001;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_DSM_FRACTIONAL_VALUE_READY_ADDR_FIELD_VALUE = 1'h1;

localparam ATX_PLL_IQCLK_MUX_SEL_VALUE = "iqtxrxclk0";
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_OFST = 272;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_OFST = 3;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_HIGH = 5;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_BITMASK = 32'h00000038;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_VALMASK = 32'h00000010;
localparam ATX_PLL_IQCLK_MUX_SEL_ADDR_FIELD_VALUE = 3'h2;

localparam ATX_PLL_VCO_BYPASS_ENABLE_VALUE = "false";
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_OFST = 259;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_OFST = 7;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_BITMASK = 32'h00000080;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_VCO_BYPASS_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_L_COUNTER_VALUE = 2;
localparam ATX_PLL_L_COUNTER_ADDR_OFST = 264;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_HIGH = 2;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_SIZE = 3;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_BITMASK = 32'h00000007;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_L_COUNTER_ADDR_FIELD_VALUE = 3'h1;

localparam ATX_PLL_L_COUNTER_ENABLE_VALUE = "true";
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_OFST = 261;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_OFST = 6;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_HIGH = 6;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_BITMASK = 32'h00000040;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_L_COUNTER_ENABLE_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_CASCADECLK_TEST_VALUE = "cascadetest_off";
localparam ATX_PLL_CASCADECLK_TEST_ADDR_OFST = 266;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_OFST = 6;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_HIGH = 6;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_BITMASK = 32'h00000040;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_CASCADECLK_TEST_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_HCLK_DIVIDE_VALUE = 1;

localparam ATX_PLL_ENABLE_HCLK_VALUE = "hclk_disabled";
localparam ATX_PLL_ENABLE_HCLK_ADDR_OFST = 263;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_HIGH = 5;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_BITMASK = 32'h00000020;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_ENABLE_HCLK_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_M_COUNTER_VALUE = 50;
localparam ATX_PLL_M_COUNTER_ADDR_OFST = 265;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_SIZE = 8;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_BITMASK = 32'h000000FF;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_VALMASK = 32'h00000032;
localparam ATX_PLL_M_COUNTER_ADDR_FIELD_VALUE = 8'h32;

localparam ATX_PLL_REF_CLK_DIV_VALUE = 1;
localparam ATX_PLL_REF_CLK_DIV_ADDR_OFST = 263;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_OFST = 2;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_HIGH = 3;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_BITMASK = 32'h0000000C;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_REF_CLK_DIV_ADDR_FIELD_VALUE = 2'h0;

localparam ATX_PLL_BW_SEL_VALUE = "low";

localparam ATX_PLL_DATARATE_VALUE = "12500000000 bps";

localparam ATX_PLL_DEVICE_VARIANT_VALUE = "device1";

localparam ATX_PLL_INITIAL_SETTINGS_VALUE = "true";

localparam ATX_PLL_LC_MODE_VALUE = "lccmu_normal";
localparam ATX_PLL_LC_MODE_ADDR_OFST = 259;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_HIGH = 0;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_BITMASK = 32'h00000001;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_VALMASK = 32'h00000001;
localparam ATX_PLL_LC_MODE_ADDR_FIELD_VALUE = 1'h1;

localparam ATX_PLL_OUTPUT_CLOCK_FREQUENCY_VALUE = "6250000000 Hz";

localparam ATX_PLL_POWERDOWN_MODE_VALUE = "powerup";

localparam ATX_PLL_PROT_MODE_VALUE = "basic_tx";

localparam ATX_PLL_REFERENCE_CLOCK_FREQUENCY_VALUE = "125000000 Hz";

localparam ATX_PLL_SUP_MODE_VALUE = "user_mode";

localparam ATX_PLL_REGULATOR_BYPASS_VALUE = "reg_enable";
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_OFST = 262;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_HIGH = 0;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_BITMASK = 32'h00000001;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_REGULATOR_BYPASS_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_VCO_FREQ_VALUE = "12500000000 Hz";

localparam ATX_PLL_IS_OTN_VALUE = "false";

localparam ATX_PLL_IS_SDI_VALUE = "false";

localparam ATX_PLL_PRIMARY_USE_VALUE = "hssi_x1";

localparam ATX_PLL_FPLL_REFCLK_SELECTION_VALUE = "select_vco_output";
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_OFST = 264;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_OFST = 4;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_HIGH = 4;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_BITMASK = 32'h00000010;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_FPLL_REFCLK_SELECTION_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_VALUE = "lcounter_setting0";
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_OFST = 264;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_OFST = 5;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_HIGH = 6;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_SIZE = 2;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_BITMASK = 32'h00000060;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR0_FIELD_VALUE = 2'h0;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_OFST = 266;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_OFST = 3;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_HIGH = 5;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_SIZE = 3;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_BITMASK = 32'h00000038;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_LC_TO_FPLL_L_COUNTER_ADDR1_FIELD_VALUE = 3'h0;

localparam ATX_PLL_PFD_DELAY_COMPENSATION_VALUE = "normal_delay";
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_OFST = 283;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_OFST = 6;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_HIGH = 7;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_BITMASK = 32'h000000C0;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_PFD_DELAY_COMPENSATION_ADDR_FIELD_VALUE = 2'h0;

localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_VALUE = "normal_setting";
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_OFST = 267;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_OFST = 0;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_HIGH = 0;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_SIZE = 1;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_BITMASK = 32'h00000001;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_XCPVCO_XCHGPMPLF_CP_CURRENT_BOOST_ADDR_FIELD_VALUE = 1'h0;

localparam ATX_PLL_PFD_PULSE_WIDTH_VALUE = "pulse_width_setting0";
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_OFST = 287;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_OFST = 5;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_HIGH = 6;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_SIZE = 2;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_BITMASK = 32'h00000060;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_VALMASK = 32'h00000000;
localparam ATX_PLL_PFD_PULSE_WIDTH_ADDR_FIELD_VALUE = 2'h0;

endpackage