// xcvr_reset_rx.v

// Generated using ACDS version 16.1 203

`timescale 1 ps / 1 ps
module xcvr_reset_rx (
		input  wire       clock,              //              clock.clk
		input  wire       reset,              //              reset.reset
		output wire [3:0] rx_analogreset,     //     rx_analogreset.rx_analogreset
		input  wire [3:0] rx_cal_busy,        //        rx_cal_busy.rx_cal_busy
		output wire [3:0] rx_digitalreset,    //    rx_digitalreset.rx_digitalreset
		input  wire [3:0] rx_is_lockedtodata, // rx_is_lockedtodata.rx_is_lockedtodata
		output wire [3:0] rx_ready            //           rx_ready.rx_ready
	);

	altera_xcvr_reset_control #(
		.CHANNELS              (4),
		.PLLS                  (1),
		.SYS_CLK_IN_MHZ        (100),
		.SYNCHRONIZE_RESET     (1),
		.REDUCED_SIM_TIME      (1),
		.TX_PLL_ENABLE         (0),
		.T_PLL_POWERDOWN       (1000),
		.SYNCHRONIZE_PLL_RESET (0),
		.TX_ENABLE             (0),
		.TX_PER_CHANNEL        (0),
		.T_TX_ANALOGRESET      (70000),
		.T_TX_DIGITALRESET     (70000),
		.T_PLL_LOCK_HYST       (0),
		.EN_PLL_CAL_BUSY       (0),
		.RX_ENABLE             (1),
		.RX_PER_CHANNEL        (0),
		.T_RX_ANALOGRESET      (70000),
		.T_RX_DIGITALRESET     (400000)
	) xcvr_reset_rx_inst (
		.clock              (clock),              //              clock.clk
		.reset              (reset),              //              reset.reset
		.rx_analogreset     (rx_analogreset),     //     rx_analogreset.rx_analogreset
		.rx_digitalreset    (rx_digitalreset),    //    rx_digitalreset.rx_digitalreset
		.rx_ready           (rx_ready),           //           rx_ready.rx_ready
		.rx_is_lockedtodata (rx_is_lockedtodata), // rx_is_lockedtodata.rx_is_lockedtodata
		.rx_cal_busy        (rx_cal_busy),        //        rx_cal_busy.rx_cal_busy
		.pll_powerdown      (),                   //        (terminated)
		.tx_analogreset     (),                   //        (terminated)
		.tx_digitalreset    (),                   //        (terminated)
		.tx_ready           (),                   //        (terminated)
		.pll_locked         (1'b0),               //        (terminated)
		.pll_select         (1'b0),               //        (terminated)
		.tx_cal_busy        (4'b0000),            //        (terminated)
		.pll_cal_busy       (1'b0),               //        (terminated)
		.tx_manual          (4'b1111),            //        (terminated)
		.rx_manual          (4'b0000),            //        (terminated)
		.tx_digitalreset_or (4'b0000),            //        (terminated)
		.rx_digitalreset_or (4'b0000)             //        (terminated)
	);

endmodule
