package require -exact qsys 14.0

foreach instance [get_instances] {
    set class_name [get_instance_property $instance CLASS_NAME]
    if {[string equal $class_name "altera_nios2_qsys"]} {
        append cpus $instance
    }
}

foreach cpu $cpus {
add_instance ${cpu}_temp altera_nios2_gen2 

foreach parameter [ get_instance_parameters $cpu ] {
	set parameter_value [ get_instance_parameter_value $cpu $parameter ]
	
	if { $parameter == "setting_branchPredictionType" && $parameter_value == "Automatic" } {
		set parameter_value "Dynamic"		
	}

	set_instance_parameter_value ${cpu}_temp $parameter $parameter_value	
}

set impl [ get_instance_parameter_value ${cpu}_temp impl ]
if { "$impl" == "Small" } {
    set_instance_parameter_value ${cpu}_temp impl "Fast"
    set_instance_parameter_value ${cpu}_temp setting_branchPredictionType "Static"
    set_instance_parameter_value ${cpu}_temp dcache_size "None"
    set_instance_parameter_value ${cpu}_temp mmu_enabled false
    set_instance_parameter_value ${cpu}_temp mpu_enabled false
    set_instance_parameter_value ${cpu}_temp setting_interruptControllerType "Internal"
    set_instance_parameter_value ${cpu}_temp dcache_numTCDM 0
}

foreach connection [ get_connections $cpu ] {
	
	set new_con $connection
	if { [ string match *d_irq* $new_con ] } {
		regsub -all "d_irq" $new_con "irq" new_con
	}
	
	if { [ string match *jtag_debug_module_reset* $new_con ] } {
		regsub -all "jtag_debug_module_reset" $new_con "debug_reset_request" new_con
	}

	if { [ string match *jtag_debug_module* $new_con ] } {
		regsub -all "jtag_debug_module" $new_con "debug_mem_slave" new_con
	}
	
	if { [ string match "*${cpu}.reset_n*" $new_con ] } {
		regsub -all "${cpu}.reset_n" $new_con "${cpu}.reset" new_con
	}

	regsub -all "$cpu" $new_con "${cpu}_temp" new_con
	
	add_connection $new_con

	set con_param [ get_connection_parameters $connection ]
	foreach con_p $con_param {
		set con_p_value [ get_connection_parameter_value $connection $con_p ]
		set_connection_parameter_value $new_con $con_p $con_p_value
	}
	
	remove_connection $connection
}

remove_instance $cpu
set_instance_property ${cpu}_temp NAME $cpu
}


save_system

